typedef struct trans {
  int src;
  int dst;
  char *lab;
} * Trans;

Trans mk_trans(int, int, char *);


typedef struct nfa {
  int vars_no;
  int *var_type;
  char **var_list;
  
  int state_no;
  int init_state;
  int acc_no;
  int *acc_list;

  int trans_no;
  Trans *trans_list;
} * Nfa;

Nfa mk_nfa(int, char **, int, int, int, int *);
void nfa_set_init(Nfa, int);
void nfa_add_trans(Nfa, int, int, char *);
void nfa_rem_trans(Nfa, int, int);

void nfa_pos(Nfa);
void nfa_dual(Nfa);
void nfa_print_xml(Nfa);

#define LINESIZE   1000

/* If using VATA output, this should be set to SYMBOL_SIZE in include/vata/symbolic.hh */
#define MAXVAR     16

#define MAXSTATES  1000
#define MAXTRANS   100000

#define FOVAR      1
#define MSOVAR     2
